/* 
	$RCSfile: DICOM_Toolkit_Register.h,v $
	$Author: konis $
	$Source: /Volumes/Cubas/cvsroot/dicom/utils/DICOM_Toolkit_Register.h,v $
	$Revision: 1.3 $
	$Name:  $
	
	$Log: DICOM_Toolkit_Register.h,v $
	Revision 1.3  2008/09/30 14:54:29  konis
	Added line-feed at the end of file to eliminate warning in Xcode.
	
	Revision 1.2  2003/07/31 09:59:39  patrinos
	Added flags parameter to RegisterDTkComponents and RegisterDTkComponentAliases.
	
	Revision 1.1  2003/04/21 13:11:51  patrinos
	First checked-in.
	
*/
#ifndef __DICOM_TOOLKIT_REGISTER__
#define __DICOM_TOOLKIT_REGISTER__

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=mac68k
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(push, 2)
#elif PRAGMA_STRUCT_PACK
	#pragma pack(2)
#endif

#ifdef __cplusplus
	extern "C" {
#endif

typedef struct DICOMComponentsStruct
{
	Component graphicsImporter;
	Component graphicsImporterAlias1;
	Component graphicsImporterAlias2;
	Component movieImporter;
	Component movieImporterAlias1;
	Component movieImporterAlias2;
	Component codec;
	Component parser;
	Component graphicsExporter;
	Component graphicsExporterAlias;
	Component VOIBlitter;
} DICOMComponentsStruct, *DICOMComponentsStructPtr;

#if TARGET_OS_MAC
#pragma export on
#endif

ComponentResult NewDICOMComponentsStruct(Ptr *aDICOMComponentsStructPtr);
ComponentResult DisposeDICOMComponentsStruct(Ptr aDICOMComponentsStructPtr);

ComponentResult RegisterDTkComponents(Ptr DICOMComponentsIn, UInt32 flags);
ComponentResult RegisterDTkComponentAliases(Ptr DICOMComponentsIn, SInt16 resFileRef, UInt32 flags);

ComponentResult UnregisterDTkComponents(Ptr DICOMComponentsIn);
ComponentResult UnregisterDTkComponentAliases(Ptr DICOMComponentsIn);

#if TARGET_OS_MAC
#pragma export off
#endif

#ifdef __cplusplus
	}
#endif

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(pop)
#elif PRAGMA_STRUCT_PACK
	#pragma pack()
#endif

#endif // __DICOM_DLL_MAIN__
