/*
     File:       DICOM_Toolkit_Standard.h

     Contains:   Escape DICOM Toolkit Interface to DICOM standard.

     Copyright:  (c)2002-2004 by Escape Information Services, all rights reserved.

     Bugs?       For support or bug reports please send email to support@escape.gr
 
*/
#ifndef __DICOM_TOOLKIT_STANDARD__
#define __DICOM_TOOLKIT_STANDARD__


#ifndef __DICOM_TOOLKIT_TYPES__
	#include "DICOM_Toolkit_Types.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT
#pragma import on
#endif

#pragma mark UID Definitions

#define kDTkVerificationSOPClass_UID "1.2.840.10008.1.1"
#define kDTkImplicitVRLittleEndian_UID "1.2.840.10008.1.2"
#define kDTkDefaultTransferSyntaxforDICOM_UID kDTkImplicitVRLittleEndian_UID
#define kDTkExplicitVRLittleEndian_UID "1.2.840.10008.1.2.1"
#define kDTkDeflatedExplicitVRLittleEndian_UID "1.2.840.10008.1.2.1.99"
#define kDTkExplicitVRBigEndian_UID "1.2.840.10008.1.2.2"
#define kDTkJPEGBaseline_Process1_UID "1.2.840.10008.1.2.4.50"
#define kDTkJPEGExtended_Process2and4_UID "1.2.840.10008.1.2.4.51"
#define kDTkJPEGExtended_Process3and5_UID "1.2.840.10008.1.2.4.52"
#define kDTkJPEGSpectralSelectionNonHierarchical_Process6and8_UID "1.2.840.10008.1.2.4.53"
#define kDTkJPEGSpectralSelectionNon_Hierarchical_Process7and9_UID "1.2.840.10008.1.2.4.54"
#define kDTkJPEGFullProgressionNonHierarchical_Process10and12_UID "1.2.840.10008.1.2.4.55"
#define kDTkJPEGFullProgressionNonHierarchical_Process11and13_UID "1.2.840.10008.1.2.4.56"
#define kDTkJPEGLosslessNonHierarchical_Process14_UID "1.2.840.10008.1.2.4.57"
#define kDTkJPEGLosslessNonHierarchical_Process15_UID "1.2.840.10008.1.2.4.58"
#define kDTkJPEGExtendedHierarchical_Process16and18_UID "1.2.840.10008.1.2.4.59"
#define kDTkJPEGExtendedHierarchical_Process17and19_UID "1.2.840.10008.1.2.4.60"
#define kDTkJPEGSpectralSelectionHierarchical_Process20and22_UID "1.2.840.10008.1.2.4.61"
#define kDTkJPEGSpectralSelectionHierarchical_Process21and23_UID "1.2.840.10008.1.2.4.62"
#define kDTkJPEGFullProgressionHierarchical_Process24and26_UID "1.2.840.10008.1.2.4.63"
#define kDTkJPEGFullProgressionHierarchical_Process25and27_UID "1.2.840.10008.1.2.4.64"
#define kDTkJPEGLosslessHierarchical_Process28_UID "1.2.840.10008.1.2.4.65"
#define kDTkJPEGLosslessHierarchical_Process29_UID "1.2.840.10008.1.2.4.66"
#define kDTkJPEGLosslessNonHierarchical_First_OrderPrediction_Process14_UID "1.2.840.10008.1.2.4.70"
#define kDTkJPEG_LSLosslessImageCompression_UID "1.2.840.10008.1.2.4.80"
#define kDTkJPEG_LSLossy_Near_LosslessImageCompression_UID "1.2.840.10008.1.2.4.81"
#define kDTkJPEG2000ImageCompression_LosslessOnly_UID "1.2.840.10008.1.2.4.90"
#define kDTkJPEG2000ImageCompression_UID "1.2.840.10008.1.2.4.91"
#define kDTkJPEG2000_MultipleComponent_ImageCompression_LosslessOnly_UID "1.2.840.10008.1.2.4.92"
#define kDTkJPEG2000_MultipleComponent_ImageCompression_UID "1.2.840.10008.1.2.4.93"
#define kDTkRLELossless_UID "1.2.840.10008.1.2.5"
#define kDTkStorageCommitmentPushModelSOPClass_UID "1.2.840.10008.1.20.1"
#define kDTkStorageCommitmentPushModelSOPInstance_UID "1.2.840.10008.1.20.1.1"
#define kDTkStorageCommitmentPullModelSOPClass_UID "1.2.840.10008.1.20.2"
#define kDTkStorageCommitmentPullModelSOPInstance_UID "1.2.840.10008.1.20.2.1"
#define kDTkMediaStorageDirectoryStorage_UID "1.2.840.10008.1.3.10"
#define kDTkBasicStudyContentNotificationSOPClass_UID "1.2.840.10008.1.9"
#define kDTkDICOMControlledTerminology_UID "1.2.840.10008.2.16.4"
#define kDTkDICOMApplicationContextName_UID "1.2.840.10008.3.1.1.1"
#define kDTkDetachedPatientManagementSOPClass_UID "1.2.840.10008.3.1.2.1.1"
#define kDTkDetachedPatientManagementMetaSOPClass_UID "1.2.840.10008.3.1.2.1.4"
#define kDTkDetachedVisitManagementSOPClass_UID "1.2.840.10008.3.1.2.2.1"
#define kDTkDetachedStudyManagementSOPClass_UID "1.2.840.10008.3.1.2.3.1"
#define kDTkStudyComponentManagementSOPClass_UID "1.2.840.10008.3.1.2.3.2"
#define kDTkModalityPerformedProcedureStepSOPClass_UID "1.2.840.10008.3.1.2.3.3"
#define kDTkModalityPerformedProcedureStepRetrieveSOPClass_UID "1.2.840.10008.3.1.2.3.4"
#define kDTkModalityPerformedProcedureStepNotificationSOPClass_UID "1.2.840.10008.3.1.2.3.5"
#define kDTkDetachedResultsManagementSOPClass_UID "1.2.840.10008.3.1.2.5.1"
#define kDTkDetachedResultsManagementMetaSOPClass_UID "1.2.840.10008.3.1.2.5.4"
#define kDTkDetachedStudyManagementMetaSOPClass_UID "1.2.840.10008.3.1.2.5.5"
#define kDTkDetachedInterpretationManagementSOPClass_UID "1.2.840.10008.3.1.2.6.1"
#define kDTkBasicFilmSessionSOPClass_UID "1.2.840.10008.5.1.1.1"
#define kDTkPrintJobSOPClass_UID "1.2.840.10008.5.1.1.14"
#define kDTkBasicAnnotationBoxSOPClass_UID "1.2.840.10008.5.1.1.15"
#define kDTkPrinterSOPClass_UID "1.2.840.10008.5.1.1.16"
#define kDTkPrinterConfigurationRetrievalSOPClass_UID "1.2.840.10008.5.1.1.16.376"
#define kDTkPrinterSOPInstance_UID "1.2.840.10008.5.1.1.17"
#define kDTkPrinterConfigurationRetrievalSOPInstance_UID "1.2.840.10008.5.1.1.17.376"
#define kDTkBasicColorPrintManagementMetaSOPClass_UID "1.2.840.10008.5.1.1.18"
#define kDTkReferencedColorPrintManagementMetaSOPClass_UID "1.2.840.10008.5.1.1.18.1"
#define kDTkBasicFilmBoxSOPClass_UID "1.2.840.10008.5.1.1.2"
#define kDTkVOILUTBoxSOPClass_UID "1.2.840.10008.5.1.1.22"
#define kDTkPresentationLUTSOPClass_UID "1.2.840.10008.5.1.1.23"
#define kDTkImageOverlayBoxSOPClass_UID "1.2.840.10008.5.1.1.24"
#define kDTkBasicPrintImageOverlayBoxSOPClass_UID "1.2.840.10008.5.1.1.24.1"
#define kDTkPrintQueueSOPInstance_UID "1.2.840.10008.5.1.1.25"
#define kDTkPrintQueueManagementSOPClass_UID "1.2.840.10008.5.1.1.26"
#define kDTkStoredPrintStorageSOPClass_UID "1.2.840.10008.5.1.1.27"
#define kDTkHardcopyGrayscaleImageStorageSOPClass_UID "1.2.840.10008.5.1.1.29"
#define kDTkHardcopyColorImageStorageSOPClass_UID "1.2.840.10008.5.1.1.30"
#define kDTkPullPrintRequestSOPClass_UID "1.2.840.10008.5.1.1.31"
#define kDTkPullStoredPrintManagementMetaSOPClass_UID "1.2.840.10008.5.1.1.32"
#define kDTkBasicGrayscaleImageBoxSOPClass_UID "1.2.840.10008.5.1.1.4"
#define kDTkBasicColorImageBoxSOPClass_UID "1.2.840.10008.5.1.1.4.1"
#define kDTkReferencedImageBoxSOPClass_UID "1.2.840.10008.5.1.1.4.2"
#define kDTkBasicGrayscalePrintManagementMetaSOPClass_UID "1.2.840.10008.5.1.1.9"
#define kDTkReferencedGrayscalePrintManagementMetaSOPClass_UID "1.2.840.10008.5.1.1.9.1"
#define kDTkComputedRadiographyImageStorage_UID "1.2.840.10008.5.1.4.1.1.1"
#define kDTkDigitalX_RayImageStorage_ForPresentation_UID "1.2.840.10008.5.1.4.1.1.1.1"
#define kDTkDigitalX_RayImageStorage_ForProcessing_UID "1.2.840.10008.5.1.4.1.1.1.1.1"
#define kDTkDigitalMammographyX_RayImageStorage_ForPresentation_UID "1.2.840.10008.5.1.4.1.1.1.2"
#define kDTkDigitalMammographyX_RayImageStorage_ForProcessing_UID "1.2.840.10008.5.1.4.1.1.1.2.1"
#define kDTkDigitalIntra_oralX_RayImageStorage_ForPresentation_UID "1.2.840.10008.5.1.4.1.1.1.3"
#define kDTkDigitalIntra_oralX_RayImageStorage_ForProcessing_UID "1.2.840.10008.5.1.4.1.1.1.3.1"
#define kDTkStandaloneModalityLUTStorage_UID "1.2.840.10008.5.1.4.1.1.10"
#define kDTkStandaloneVOILUTStorage_UID "1.2.840.10008.5.1.4.1.1.11"
#define kDTkGrayscaleSoftcopyPresentationStateStorageSOPClass_UID "1.2.840.10008.5.1.4.1.1.11.1"
#define kDTkX_RayAngiographicImageStorage_UID "1.2.840.10008.5.1.4.1.1.12.1"
#define kDTkX_RayRadiofluoroscopicImageStorage_UID "1.2.840.10008.5.1.4.1.1.12.2"
#define kDTkX_RayAngiographicBi_PlaneImageStorage_UID "1.2.840.10008.5.1.4.1.1.12.3"
#define kDTkPositronEmissionTomographyImageStorage_UID "1.2.840.10008.5.1.4.1.1.128"
#define kDTkStandalonePETCurveStorage_UID "1.2.840.10008.5.1.4.1.1.129"
#define kDTkCTImageStorage_UID "1.2.840.10008.5.1.4.1.1.2"
#define kDTkNuclearMedicineImageStorage_UID "1.2.840.10008.5.1.4.1.1.20"
#define kDTkUltrasoundMulti_frameImageStorage_UID_Retired "1.2.840.10008.5.1.4.1.1.3"
#define kDTkUltrasoundMulti_frameImageStorage_UID "1.2.840.10008.5.1.4.1.1.3.1"
#define kDTkMRImageStorage_UID "1.2.840.10008.5.1.4.1.1.4"
#define kDTkEnhancedMRImageStorage_UID "1.2.840.10008.5.1.4.1.1.4.1"
#define kDTkMRSpectroscopyStorage_UID "1.2.840.10008.5.1.4.1.1.4.2"
#define kDTkRTImageStorage_UID "1.2.840.10008.5.1.4.1.1.481.1"
#define kDTkRTDoseStorage_UID "1.2.840.10008.5.1.4.1.1.481.2"
#define kDTkRTStructureSetStorage_UID "1.2.840.10008.5.1.4.1.1.481.3"
#define kDTkRTBeamsTreatmentRecordStorage_UID "1.2.840.10008.5.1.4.1.1.481.4"
#define kDTkRTPlanStorage_UID "1.2.840.10008.5.1.4.1.1.481.5"
#define kDTkRTBrachyTreatmentRecordStorage_UID "1.2.840.10008.5.1.4.1.1.481.6"
#define kDTkRTTreatmentSummaryRecordStorage_UID "1.2.840.10008.5.1.4.1.1.481.7"
#define kDTkNuclearMedicineImageStorage_UID_Retired "1.2.840.10008.5.1.4.1.1.5"
#define kDTkUltrasoundImageStorage_UID_Retired "1.2.840.10008.5.1.4.1.1.6"
#define kDTkUltrasoundImageStorage_UID "1.2.840.10008.5.1.4.1.1.6.1"
#define kDTkRawDataStorage_UID "1.2.840.10008.5.1.4.1.1.66"
#define kDTkSecondaryCaptureImageStorage_UID "1.2.840.10008.5.1.4.1.1.7"
#define kDTkMulti_frameSingleBitSecondaryCaptureImageStorage_UID "1.2.840.10008.5.1.4.1.1.7.1"
#define kDTkMulti_frameGrayscaleByteSecondaryCaptureImageStorage_UID "1.2.840.10008.5.1.4.1.1.7.2"
#define kDTkMulti_frameGrayscaleWordSecondaryCaptureImageStorage_UID "1.2.840.10008.5.1.4.1.1.7.3"
#define kDTkMulti_frameTrueColorSecondaryCaptureImageStorage_UID "1.2.840.10008.5.1.4.1.1.7.4"
#define kDTkVLImageStorage_UID "1.2.840.10008.5.1.4.1.1.77.1"
#define kDTkVLEndoscopicImageStorage_UID "1.2.840.10008.5.1.4.1.1.77.1.1"
#define kDTkVLMicroscopicImageStorage_UID "1.2.840.10008.5.1.4.1.1.77.1.2"
#define kDTkVLSlide_CoordinatesMicroscopicImageStorage_UID "1.2.840.10008.5.1.4.1.1.77.1.3"
#define kDTkVLPhotographicImageStorage_UID "1.2.840.10008.5.1.4.1.1.77.1.4"
#define kDTkVLMulti_frameImageStorage_UID "1.2.840.10008.5.1.4.1.1.77.2"
#define kDTkStandaloneOverlayStorage_UID "1.2.840.10008.5.1.4.1.1.8"
#define kDTkBasicTextSR_UID "1.2.840.10008.5.1.4.1.1.88.11"
#define kDTkEnhancedSR_UID "1.2.840.10008.5.1.4.1.1.88.22"
#define kDTkComprehensiveSR_UID "1.2.840.10008.5.1.4.1.1.88.33"
#define kDTkMammographyCADSR_UID "1.2.840.10008.5.1.4.1.1.88.50"
#define kDTkKeyObjectSelectionDocument_UID "1.2.840.10008.5.1.4.1.1.88.59"
#define kDTkChestCADSR_UID "1.2.840.10008.5.1.4.1.1.88.65"
#define kDTkStandaloneCurveStorage_UID "1.2.840.10008.5.1.4.1.1.9"
#define kDTk12_leadECGWaveformStorage_UID "1.2.840.10008.5.1.4.1.1.9.1.1"
#define kDTkGeneralECGWaveformStorage_UID "1.2.840.10008.5.1.4.1.1.9.1.2"
#define kDTkAmbulatoryECGWaveformStorage_UID "1.2.840.10008.5.1.4.1.1.9.1.3"
#define kDTkHemodynamicWaveformStorage_UID "1.2.840.10008.5.1.4.1.1.9.2.1"
#define kDTkCardiacElectrophysiologyWaveformStorage_UID "1.2.840.10008.5.1.4.1.1.9.3.1"
#define kDTkBasicVoiceAudioWaveformStorage_UID "1.2.840.10008.5.1.4.1.1.9.4.1"
#define kDTkPatientRootQuery_RetrieveInformationModel_FIND_UID "1.2.840.10008.5.1.4.1.2.1.1"
#define kDTkPatientRootQuery_RetrieveInformationModel_MOVE_UID "1.2.840.10008.5.1.4.1.2.1.2"
#define kDTkPatientRootQuery_RetrieveInformationModel_GET_UID "1.2.840.10008.5.1.4.1.2.1.3"
#define kDTkStudyRootQuery_RetrieveInformationModel_FIND_UID "1.2.840.10008.5.1.4.1.2.2.1"
#define kDTkStudyRootQuery_RetrieveInformationModel_MOVE_UID "1.2.840.10008.5.1.4.1.2.2.2"
#define kDTkStudyRootQuery_RetrieveInformationModel_GET_UID "1.2.840.10008.5.1.4.1.2.2.3"
#define kDTkPatient_StudyOnlyQuery_RetrieveInformationModel_FIND_UID "1.2.840.10008.5.1.4.1.2.3.1"
#define kDTkPatient_StudyOnlyQuery_RetrieveInformationModel_MOVE_UID "1.2.840.10008.5.1.4.1.2.3.2"
#define kDTkPatient_StudyOnlyQuery_RetrieveInformationModel_GET_UID "1.2.840.10008.5.1.4.1.2.3.3"
#define kDTkModalityWorklistInformationModel_FIND_UID "1.2.840.10008.5.1.4.31"
#define kDTkGeneralPurposeWorklistManagementMetaSOPClass_UID "1.2.840.10008.5.1.4.32"
#define kDTkGeneralPurposeWorklistInformationModel_FIND_UID "1.2.840.10008.5.1.4.32.1"
#define kDTkGeneralPurposeScheduledProcedureStepSOPClass_UID "1.2.840.10008.5.1.4.32.2"
#define kDTkGeneralPurposePerformedProcedureStepSOPClass_UID "1.2.840.10008.5.1.4.32.3"

/*!
    @header DICOM_Toolkit_Standard.h
    @discussion This header includes the declarations of the toolkit 
    			functions that provide access to miscellaneous info from 
    			the DICOM standard.
*/

#pragma export on

#pragma mark DTkStandardGetDictInfoForTag
/*!
    @function DTkStandardGetDictInfoForTag
    @abstract Returns complete DICOM dictionary information about DICOM attributes, as available in PS 3.6
    @param flags              [I] Flags that specialize the functionality of the call.
							      Currently only the kDTkStandardFlagIgnoreSpecialSequenceVRs = (1L << 0) is recognized.
    @param elementTagPtr      [I] Pointer to a DICOM element's tag structure
    @param elementTagDictInfo [O] Address of the DTkTagDictInfo structure to be filled by the function.
    @result Error code
*/
ComponentResult DTkStandardGetDictInfoForTag(UInt32 flags, DTkElementTagPtr elementTagRecPtr, DTkTagDictInfoPtr elementTagDictInfo);


#pragma mark DTkStandardFindElemInVector
/*!
    @function DTkStandardFindElemInVector
    @abstract General function that appropriately fills a strcture passed to it with information from the DICOM standard
    @param keyElemIdx			  [I] Zero-based index of key field within the structure
    @param keyData                [I] Search key
    @param DTkElemRecTypeSelector [O] Selector that specifies the type of structure passed via the elemStructPtr parameter.							          
    @param elemStructPtr          [O] Address of the structure to be filled by the function.
    @result Error code
    @Discussion Currently two selectors are supported, kDTkElemRecTypeSel_UIDRegistryElem and kDTkElemRecTypeSel_StandardSOPClassElem 
                that correspond to the DTkUIDInfoRecElem and the DTkStandardSOPClassElem structures. In both cases only the first 
                field is acceptable as a key (i.e. keyElemIdx -> 0).
*/
ComponentResult DTkStandardFindElemInVector(UInt32 keyElemIdx, void * keyData, DTkElemRecTypeSelector elemRecType, void **elemStructPtr);


#pragma export off

#ifdef PRAGMA_IMPORT_OFF
#pragma import off
#elif PRAGMA_IMPORT
#pragma import reset
#endif

#ifdef __cplusplus
}
#endif


#endif // __DICOM_TOOLKIT_STANDARD__
